#!/usr/bin/python

class ABinTree(list):
	def parent(self,i):
		if i<len(self) and i>0 :
			return (i-1)/2
	
	def left(self,i):
		if 2*i+1<len(self):
			return 2*i+1

	def right(self,i):
		if 2*i+2<len(self):
			return 2*i+2

	def leftSibling(self,i):
		if i<len(self) and i>0 and not i%2:
			return i-1

	def rightSibling(self,i):
		if i+1<len(self) and i%2:
			return i+1

	def isLeaf(self,i):
		return not (self.left(i) or self.right(i))
	
	def __getitem__(self,key):
		try :
			return list.__getitem__(self,key)
		except TypeError :
			return None

	def heapify(self,i):
		if i==None or self.isLeaf(i):
			return
		self.heapify(self.left(i))
		self.heapify(self.right(i))
		old=self[i]
		print i, ':', self[i],self[self.left(i)],self[self.right(i)], '->',
		new=max(self[i],self[self.left(i)],self[self.right(i)])
		print new
		self[i]=new
		if self[self.left(i)]==new : 
			self[self.left(i)]=old
			self.heapify(self.left(i))
		elif self[self.right(i)]==new :
			self[self.right(i)]=old
			self.heapify(self.right(i))
		print self

if __name__ == '__main__' :
	t=ABinTree(range(12))
	print 'tree =', t
	t.heapify(0)
	print 'heap =', t
